## iceweasel 10.0.12esr

=== debian/changelog ===
iceweasel (10.0.12esr-1~bpo60+1) squeeze-backports; urgency=low

  * Rebuild for squeeze-backports.
  * js/src/configure.in: Disable -fstrict-aliasing in JS for GCC 4.4 and
    earlier, due to miscompilation.

 -- Mike Hommey <glandium@debian.org>  Sat, 19 Jan 2013 09:34:29 +0100

iceweasel (10.0.12esr-1) unstable; urgency=low

  * New upstream release.
  * Fixes for mfsa2013-{01-02,04,09,11-12,15-18}, also known as
    CVE-2013-0769, CVE-2013-0762, CVE-2013-0766, CVE-2013-0767,
    CVE-2012-0759, CVE-2013-0744, CVE-2013-0746, CVE-2013-0748,
    CVE-2013-0750, CVE-2013-0758, CVE-2013-0753, CVE-2013-0754,
    CVE-2013-0755.

 -- Mike Hommey <glandium@debian.org>  Tue, 08 Jan 2013 21:06:38 +0100

iceweasel (10.0.11esr-1) unstable; urgency=high

  * New upstream release.
  * Fixes for mfsa2012-{91-93,98,100-101,103-106}, also known as
    CVE-2012-5842, CVE-2012-4202, CVE-2012-4201, CVE-2012-4206,
    CVE-2012-5841, CVE-2012-4207, CVE-2012-4209, CVE-2012-4210,
    CVE-2012-4214, CVE-2012-4215, CVE-2012-4216, CVE-2012-5829,
    CVE-2012-5839, CVE-2012-5840, CVE-2012-5830, CVE-2012-5833,
    CVE-2012-5835.

 -- Mike Hommey <glandium@debian.org>  Tue, 20 Nov 2012 23:26:21 +0100

iceweasel (10.0.10esr-1) unstable; urgency=high

  * New upstream release.
  * Fixes for mfsa2012-90, also known as CVE-2012-4194 and CVE-2012-4196.

 -- Mike Hommey <glandium@debian.org>  Fri, 26 Oct 2012 15:19:35 +0200

iceweasel (10.0.9esr-1) unstable; urgency=high

  * New upstream release.
  * Fixes for mfsa2012-89, also known as CVE-2012-4192 and CVE-2012-4193.

 -- Mike Hommey <glandium@debian.org>  Sat, 13 Oct 2012 00:05:54 +0200

iceweasel (10.0.8esr-1) unstable; urgency=low

  * New upstream release.
  * Fixes for mfsa2012-{74,77,79,81-87}, also known as
    CVE-2012-3982, CVE-2012-3985, CVE-2012-3986, CVE-2012-3988,
    CVE-2012-3991, CVE-2012-3994, CVE-2012-3993, CVE-2012-4184,
    CVE-2012-3992, CVE-2012-3995, CVE-2012-4179, CVE-2012-4180,
    CVE-2012-4181, CVE-2012-4182, CVE-2012-4185, CVE-2012-4186,
    CVE-2012-4187, CVE-2012-4188, CVE-2012-3990.

 -- Mike Hommey <glandium@debian.org>  Tue, 09 Oct 2012 15:24:26 +0200

iceweasel (10.0.7esr-2) unstable; urgency=low

  * debian/rules: Use xz compression for binary packages. Closes: #686325.

  * widget/src/xpwidgets/GfxInfoX11.cpp: Allow webGL with mesa,
    assuming users will have updated to 8.0.4-2 on wheezy. The version
    in squeeze-backports is not affected by CVE-2012-2864, and the
    version in squeeze is blacklisted.

 -- Mike Hommey <glandium@debian.org>  Fri, 31 Aug 2012 09:20:36 +0200

iceweasel (10.0.7esr-1) unstable; urgency=low

  * New upstream release.
  * Fixes for mfsa2012-{57-58,60-63,65,69-70,72}, also known as
    CVE-2012-1970, CVE-2012-1972, CVE-2012-1973, CVE-2012-1974,
    CVE-2012-1975, CVE-2012-1976, CVE-2012-3957, CVE-2012-3959,
    CVE-2012-3960, CVE-2012-3962, CVE-2012-3966, CVE-2012-3967,
    CVE-2012-3969, CVE-2012-3972, CVE-2012-3976, CVE-2012-3978,
    CVE-2012-3980.
  * debian/rules: Also use an epoch for iceweasel-l10n-all.

 -- Mike Hommey <glandium@debian.org>  Wed, 29 Aug 2012 08:16:59 +0200

iceweasel (10.0.6esr-2) unstable; urgency=low

  * accessible/src/atk/Makefile.in,
    accessible/src/atk/nsApplicationAccessibleWrap.cpp,
    accessible/src/base/nsAccessibilityService.h,
    widget/src/gtk2/nsWindow.cpp, widget/src/gtk2/nsWindow.h: Better detect
    a11y in GNOME 3. bz#693343. Closes: #682914.

 -- Mike Hommey <glandium@debian.org>  Fri, 03 Aug 2012 09:15:33 +0200

iceweasel (10.0.6esr-1) unstable; urgency=high

  * New upstream release.
  * Fixes for mfsa2012-{42-49,51-56}, also known as
    CVE-2012-1948, CVE-2012-1950, CVE-2012-1951, CVE-2012-1954,
    CVE-2012-1953, CVE-2012-1952, CVE-2012-1966, CVE-2012-1955,
    CVE-2012-1957, CVE-2012-1958, CVE-2012-1959, CVE-2012-1961,
    CVE-2012-1962, CVE-2012-1963, CVE-2012-1964, CVE-2012-1965,
    CVE-2012-1967.

 -- Mike Hommey <glandium@debian.org>  Tue, 17 Jul 2012 10:55:36 +0200

iceweasel (10.0.5esr-2) unstable; urgency=low

  * debian/control*: Change font suggestions for MathML. Closes: #679469.
  * dom/ipc/Makefile.in, dom/ipc/PBrowser.ipdl, dom/ipc/TabMessageUtils.cpp:
    Only export TabMessageUtils.h in mozilla/dom. bz#761082. Closes: #675920.

 -- Mike Hommey <glandium@debian.org>  Fri, 29 Jun 2012 09:45:47 +0200

iceweasel (10.0.5esr-1) unstable; urgency=high

  * New upstream release.
  * Fixes for mfsa2012-{34,36-38,40}, also known as
    CVE-2012-1939, CVE-2012-1937, CVE-2011-3101, CVE-2012-1944,
    CVE-2012-1945, CVE-2012-1946, CVE-2012-1947, CVE-2012-1940,
    CVE-2012-1941.

 -- Mike Hommey <glandium@debian.org>  Tue, 05 Jun 2012 08:51:58 +0200

iceweasel (10.0.4esr-3) unstable; urgency=low

  * debian/xulrunner-GRE_VERSION.1.in:  Fix xulrunner-x.y manual page to say
    XULRunner instead of Iceweasel.
  * debian/rules: Also set LDFLAGS from dpkg-buildflags (although in practice
    it changes nothing because relro is disabled)
  * debian/control*:
    - Force build and runtime dependency on libsqlite3-0 >= 3.7.12-1~ for a
      right value of SQLITE_MAX_SCHEMA_RETRY and SQLITE_MAX_DEFAULT_PAGE_SIZE.
    - Suggest fonts-lyx. Closes: #673222.
    - Make xulrunner-dbg depend on nspr and nss debug packages.
  * debian/xulrunner-GRE_VERSION.links.in,
    debian/xulrunner-GRE_VERSION.install.in: Move omni.ja to
    /usr/lib/xulrunner-x.0 because it contains arch-depend data.

  * ipc/chromium/src/base/file_util_linux.cc,
    ipc/chromium/src/base/message_pump_libevent.cc,
    ipc/chromium/src/base/time_posix.cc: gcc 4.7 build failures (missing
    headers). bz#725655.
  * layout/base/tests/TestPoisonArea.cpp: fix build failures with Clang and
    GCC 4.7 in TestPoisonArea.cpp. bz#734490.
  * ipc/chromium/src/base/file_util.cc: Fix for error: ‘ftruncate’ was not
    declared in this scope. bz#706724.
  * widget/src/gtk2/nsGtkCursors.h, widget/src/gtk2/nsWindow.cpp:
    Try creating a named cursor before a bitmap cursor. bz#709259.

