=== debian/control ===
--- 
+++ 
@@ -20,12 +20,12 @@
                libreadline-dev | libreadline5-dev,
                python,
                python-ply,
-               dpkg-dev (>= 1.13.19),
+               dpkg-dev (>= 1.16.1.1~),
                libnspr4-dev (>= 4.8.8),
                libnss3-dev (>= 3.13.1),
                libhunspell-dev (>= 1.2),
                libdbus-glib-1-dev,
-               libsqlite3-dev (>= 3.7.7.1),
+               libsqlite3-dev (>= 3.7.12-1~),
                libasound2-dev [linux-any],
                libiw-dev [linux-any],
                libnotify-dev,
@@ -45,7 +45,6 @@
                imagemagick,
                librsvg2-bin,
                xsltproc,
-               lsb-release
 Build-Conflicts: graphicsmagick-imagemagick-compat,
                  liboss4-salsa-dev,
                  libhildonmime-dev,
@@ -61,10 +60,9 @@
          fontconfig,
          procps,
          debianutils (>= 1.16),
-         xulrunner-10.0 (>= ${binary:Version})
-Suggests: ttf-lyx | latex-xft-fonts,
-          xfonts-mathml,
-          ttf-mathematica4.1,
+         xulrunner-10.0 (>= ${binary:Version}),
+         libsqlite3-0 (>= 3.7.12-1~)
+Suggests: fonts-stix | otf-stix,
           mozplugger,
           libgssapi-krb5-2 | libkrb53
 Provides: www-browser,
@@ -212,6 +210,8 @@
 Architecture: any
 Depends: xulrunner-10.0 (= ${binary:Version}),
          libmozjs10d-dbg (= ${binary:Version}),
+         libnss3-dbg | libnss3-1d-dbg,
+         libnspr4-dbg | libnspr4-0d-dbg,
          ${misc:Depends}
 Description: Debugging symbols for the Gecko engine library
  This library provides an  API for XUL applications and Gecko embedders.
@@ -241,7 +241,6 @@
 Section: localization
 Depends: ${misc:Depends},
          iceweasel (>= ${source:Version}), iceweasel (<< ${source:Version}.1~)
-Recommends: 
 Description: Afrikaans language package for Iceweasel
  Iceweasel is Firefox, rebranded. It is a powerful, extensible web browser
  with support for modern web application technologies.
@@ -253,7 +252,6 @@
 Section: localization
 Depends: ${misc:Depends},
          iceweasel (>= ${source:Version}), iceweasel (<< ${source:Version}.1~)
-Recommends: 
 Description: Akan language package for Iceweasel
  Iceweasel is Firefox, rebranded. It is a powerful, extensible web browser
  with support for modern web application technologies.
@@ -265,7 +263,6 @@
 Section: localization
 Depends: ${misc:Depends},
          iceweasel (>= ${source:Version}), iceweasel (<< ${source:Version}.1~)
-Recommends: 
 Description: Arabic language package for Iceweasel
  Iceweasel is Firefox, rebranded. It is a powerful, extensible web browser
  with support for modern web application technologies.
