=== debian/rules ===
--- 
+++ 
@@ -1,9 +1,16 @@
 #!/usr/bin/make -f
 ifeq (,$(shell dh_testdir || echo no))
 include debian/make.mk
-DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
-DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
-DEB_BUILD_ARCH  ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
+# Use dpkg-buildflags to get hardening flags, exclude non-hardening flags,
+# and disable read-only relocations.
+dpkg_buildflags = $(and $(1),$(shell DEB_BUILD_MAINT_OPTIONS=hardening=-relro DEB_CFLAGS_MAINT_STRIP="$(shell DEB_BUILD_MAINT_OPTIONS=hardening=-all dpkg-buildflags --get $(1))" dpkg-buildflags --get $(1)))
+$(call lazy,CFLAGS,$$(call dpkg_buildflags,CFLAGS))
+$(call lazy,CPPFLAGS,$$(call dpkg_buildflags,CPPFLAGS))
+$(call lazy,LDFLAGS,$$(call dpkg_buildflags,LDFLAGS))
+
+$(call lazy,DEB_HOST_GNU_TYPE,$$(shell dpkg-architecture -qDEB_HOST_GNU_TYPE))
+$(call lazy,DEB_BUILD_GNU_TYPE,$$(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE))
+$(call lazy,DEB_BUILD_ARCH,$$(shell dpkg-architecture -qDEB_BUILD_ARCH))
 
 PYTHON := python -B
 
@@ -12,6 +19,7 @@
 include debian/upstream.mk
 
 OFFICIAL_BRANDING := browser/branding/official
+BRANDING := debian/branding
 
 # Betas and Releases need to set MOZ_UA_BUILDID
 ifeq (,$(word 2,$(subst ~a, ,$(UPSTREAM_RELEASE))))
@@ -22,7 +30,7 @@
 LIB_DIR := /usr/lib/iceweasel
 SHARE_DIR := /usr/share/iceweasel
 
-MAIN_LDFLAGS := -Wl,--as-needed
+LDFLAGS := -Wl,--as-needed
 
 AUTOCONF_DIRS := build/autoconf js/src/build/autoconf
 
@@ -64,9 +72,10 @@
 ifeq (default,$(origin CXX))
 CXX := g++
 endif
-CXXFLAGS := $(CFLAGS)
-
-export CC CXX CFLAGS CXXFLAGS
+CXXFLAGS = $(CFLAGS)
+
+EXPORTS := CC CXX CFLAGS CXXFLAGS CPPFLAGS
+$(call lazy,CONFIGURE_ENV,$$(foreach export,$(EXPORTS),$$(export)="$$($$(export))"))
 
 GENERATED_FILES += debian/dh/dh_xulrunner.1
 
@@ -86,25 +95,13 @@
 GENERATED_FILES += $(filter-out debian/control,$(PREPROCESSED_FILES))
 debian/control: debian/rules debian/changelog debian/l10n/iceweasel-l10n.control
 
-L10N_PACKAGES = $(foreach lang,$(L10N_LANGS),$(shell echo iceweasel-l10n-$(lang) | tr A-Z a-z))
-L10N_PACKAGES_CONTROLS = $(foreach pkg,$(L10N_PACKAGES),debian/l10n/$(pkg).control)
-L10N_PACKAGES_DEPS = $(shell echo $(L10N_PACKAGES) | sed 's/ /, /g')
-REMOVE_L10N_PACKAGES_CONTROLS = $(foreach ctrl,$(filter-out $(L10N_PACKAGES_CONTROLS),$(wildcard debian/l10n/iceweasel-l10n-*.control)),$(ctrl)-rm)
-
-$(REMOVE_L10N_PACKAGES_CONTROLS): %-rm:
-	rm $*
-
-debian/l10n/iceweasel-l10n.control: $(L10N_PACKAGES_CONTROLS) $(REMOVE_L10N_PACKAGES_CONTROLS)
-	@($(foreach file,$(L10N_PACKAGES_CONTROLS),echo;echo "%include $(notdir $(file))";)) > $@
-
-$(L10N_PACKAGES_CONTROLS): debian/l10n/iceweasel-l10n-%.control: debian/l10n/iceweasel-l10n.control.in
-	$(PYTHON) config/Preprocessor.py --marker % -Fsubstitution -DL10N_LANG=$* -DL10N_LANGUAGE="${shell isoquery -n -i $(if $(shell isoquery -n -i 639-3 $(firstword $(subst -, ,$*)) 2> /dev/null),639-3,639) $(firstword $(subst -, ,$*)) | awk -F\\t '{print $$NF}' | awk -F' *[(;]' '{print $$1}' | awk -F', ' '$$2 {print $$2,$$1} !$$2 {print $$1}'}$(if $(word 2,$(subst -, ,$*)), ($(shell isoquery -n -i 3166 $(word 2,$(subst -, ,$*)) | awk -F[\\t,] '{print $$4}')))" -DL10N_RECOMMENDS="$(shell awk -F': *' '$$1 == "$*" {print $$2}' debian/l10n/recommends)" $< > $@
-
-ifeq ($(shell lsb_release -sc),lenny)
-DICT_DIR := /usr/share/myspell/dicts
-else
+$(call lazy,L10N_PACKAGES,$$(foreach lang,$$(L10N_LANGS),iceweasel-l10n-$$(call lc,$$(lang))))
+$(call lazy,L10N_PACKAGES_DEPS,$$(shell echo $$(L10N_PACKAGES) | sed 's/ /, /g'))
+
+debian/l10n/iceweasel-l10n.control: %: %.in
+	$(PYTHON) debian/l10n/gen $(L10N_LANGS) > $@
+
 DICT_DIR := /usr/share/hunspell
-endif
 
 $(PREPROCESSED_FILES): VARS = GRE_VERSION JS_SO_VERSION DICT_DIR
 debian/control: VARS += L10N_PACKAGES_DEPS
@@ -133,10 +130,11 @@
 	cd build-xulrunner && \
 	MOZCONFIG=$(CURDIR)/debian/xulrunner.mozconfig \
 	ASFLAGS="-g" \
+	$(CONFIGURE_ENV) \
 	../configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr $(CONFIGURE_FLAGS) \
 		--with-default-mozilla-five-home=/usr/lib/xulrunner-$(GRE_VERSION)
-	sed -i '/^OS_LDFLAGS/s|=|& $(MAIN_LDFLAGS)|' build-xulrunner/config/autoconf.mk
-	sed -i '/^OS_LDFLAGS/s|=|& $(MAIN_LDFLAGS)|' build-xulrunner/js/src/config/autoconf.mk
+	sed -i '/^OS_LDFLAGS/s|=|& $(LDFLAGS)|' build-xulrunner/config/autoconf.mk
+	sed -i '/^OS_LDFLAGS/s|=|& $(LDFLAGS)|' build-xulrunner/js/src/config/autoconf.mk
 
 stamps/configure-check-xulrunner:: stamps/configure-xulrunner
 # Ensure --{with,enable}-system options properly set expected variables
@@ -170,10 +168,12 @@
 	$(if $(wildcard build-browser),,mkdir build-browser)
 	cd build-browser && \
 	MOZCONFIG=$(CURDIR)/debian/iceweasel.mozconfig \
+	$(CONFIGURE_ENV) \
 	../configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr $(CONFIGURE_FLAGS) \
 		--with-libxul-sdk=$(CURDIR)/build-xulrunner/dist \
+		--with-branding=$(BRANDING) \
 		--with-system-libxul --with-system-nspr --with-system-nss
-	sed -i '/^OS_LDFLAGS/s|=|& $(MAIN_LDFLAGS)|' build-browser/config/autoconf.mk
+	sed -i '/^OS_LDFLAGS/s|=|& $(LDFLAGS)|' build-browser/config/autoconf.mk
 
 stamps/build-browser:: stamps/configure-browser
 	dh_auto_build --builddirectory=build-browser
@@ -197,3 +197,16 @@
 	$(if $(wildcard l10n),,mkdir -p l10n)
 	$(if $(wildcard l10n/$*),,ln -sf ../l10n-$* l10n/$*)
 	$(PYTHON) config/pythonpath.py -I$(CURDIR)/compare-locales/lib $(CURDIR)/compare-locales/scripts/compare-locales -m $(CURDIR)/build-browser/l10n-$* browser/locales/l10n.ini $(CURDIR)/l10n $*
+	$(MAKE) -C build-browser/browser/locales langpack-$* L10NBASEDIR=$(CURDIR)/l10n MOZ_CHROME_FILE_FORMAT=flat MOZ_LANGPACK_EID=langpack-$*@iceweasel.mozilla.org PKG_LANGPACK_BASENAME='$$(MOZ_LANGPACK_EID)' PKG_LANGPACK_PATH=xpi/ LOCALE_MERGEDIR=$(CURDIR)/build-browser/l10n-$*
+
+override_dh_auto_build: stamps/build-check-branding stamps/build-check-resources
+
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+include debian/test.mk
+endif
+
+override_dh_auto_clean::
+	rm -f MPL
+	rm -f $(GENERATED_FILES) config/Expression.py[co]
+	rm -rf stamps l10n
+
